This document is a modification from !gcc.docs.gccuser of the *Reporting Bugs* section.


Reporting Bugs
**************

   Your bug reports play an essential role in making Q-System reliable.

   When you encounter a problem, the first thing to do is to see if it is already known.  If it isn't known, then you should report the problem.

   Reporting a bug may help you by bringing a solution to your problem, or it may not. In any case, the principal function of a bug report is to help the entire community by making the next version of Q-System work better.  Bug reports are your contribution to the maintenance of Q-System and should be sent by e-mail to the address in the section *Where to report bugs*. If you do not have access to e-mail, then try posting the problem to the s-mail address given.

   Since I am very busy (final year), I cannot respond to every bug report, although I will try to cure as many as possible.

   In order for a bug report to serve its purpose, you must include the information that makes for fixing the bug.

Have You Found a Bug?
=====================

   If you are not sure whether you have found a bug, here are some guidelines:

   * If the program gets a fatal signal, for some input, that is a bug.
     Reliable programs never crash.

   * If the program produces invalid results, for some input whatever,
     that is a bug.

   * If the program produces output that does not correctly correspond
     to the input, that is a bug.

   * If the program produces an error message for valid input, that is
     a bug.

   * If the program does not produce an error message for invalid
     input, that is a bug.

   * Improvements: not technically bugs, but suggestions for improvement
     of Q-System are always welcome.

Where to Report Bugs
====================


Bug reports should be sent to:
  Stu Smith: s.d.smith@ex.ac.uk
until June 1998

Or by s-mail (anytime) to:-

Stu Smith
16 Foyle Road
Chandlers Ford
Eastleigh
HANTS
SO53 4QP

How to Report Bugs
==================

   The fundamental principle of reporting bugs usefully is this:
*report all the facts*.  If you are not sure whether to state a fact or leave it out, state it!

   Often people omit facts because they think they know what causes the problem and they conclude that some details don't matter.  Thus, you might assume that the name of the variable you use in an example does not matter.  Well, probably it doesn't, but one cannot be sure. Perhaps the bug is a stray memory reference which happens to fetch from
the location where that name is stored in memory; perhaps, if the name were different, the contents of that location would fool the compiler into doing the right thing despite the bug.  Play it safe and give a specific, complete example.  That is the easiest thing for you to do, and the most helpful.

   Keep in mind that the purpose of a bug report is to enable someone to fix the bug if it is not known.  It isn't very important what happens if the bug is already known.  Therefore, always write your bug reports on the assumption that the bug is not known.

   Sometimes people give a few sketchy facts and ask, "Does this ring a bell?"  This cannot help me fix a bug, so it is basically useless.  I will respond by asking for enough details to enable us to investigate.  You might as well expedite matters by sending  them to begin with.

   Try to make your bug report self-contained.  If I have to ask you for more information, it is best if you include all the previous information in your response, as well as the information that was missing.

   Please report each bug in a separate message.  This makes it easier for me to track which bugs have been fixed and to forward your bugs reports to the appropriate maintainer.

   To enable someone to investigate the bug, you should include all these things:

   * The version of the program.  You can get this by running it with the
     `-v' option.

   * All debug output possible (symbol maps, -t, -d etc).

   * Complete input file(s) that will reproduce the bug.

   * The command arguments you gave. To guarantee you won't omit something
     important, list all the options.

   * The type of machine you are using, and the operating system name
     and version number.

   * A description of what behavior you observe that you believe is
     incorrect.  For example, "The program gets a fatal signal," or,
     "The assembler instruction at line 208 in the output is incorrect."
